#!/usr/bin/python


"""
This python source file is part of PyDCS project.  This is licensed under the
GNU General Public License version 2 (see COPYING) or later.

 Author : Sreejith K
 Email : sreejithemk@gmail.com
 Web : http://sreejithemk.net
 Copyright (C) 2008 Sreejith K
"""



### Contains the GUI design for the Simulation software
### Written using Tkinter and Pmw

from logic import *
from logic2 import *
from Tkinter import *
import Pmw

class pydcs(Frame):
    def __init__(self,master=None):
        Frame.__init__(self,master)
	self.Initialize()
        self.grid()
        self.createWidgets()

    def Initialize(self):
	self.save1 = None
	self.save2 = None
	self.CurClk = 0
	self.preclock = 1
	self.OrOb = {}
	self.AndOb = {}
	self.NotOb = {} 
	self.NandOb = {}
	self.NorOb = {}
	self.XorOb = {}
	self.XnorOb = {}
	self.FAdderOb = {}
	self.HAdderOb = {}
	self.Div2Ob = {}
	self.CounterOb = {}
	self.LatchOb = {}
	self.FlipOb = {}
	self.NodeOb = {}
	self.ClockOb = {}
	self.info = []


    
    def AboutWin(self):
	Pmw.initialise()
	Pmw.aboutversion('1.0')
	Pmw.aboutcopyright('Programmer : Sreejith K\nLicensed Under GNU General Public License v2')
	Pmw.aboutcontact('For information about this application contact:\n' + ' www.sreejithemk.blogspot.com\n' +' Phone: +919446209462\n' +' email: sreejithemk@gmail.com')
	about = Pmw.AboutDialog(self, applicationname='PyDCS')

    
    def makeCommandMenu(self):
        self.CmdBtn = Menubutton(self.mBar, text='File', underline=0)
        self.CmdBtn.pack(side=LEFT, padx="1m")
        self.CmdBtn.menu = Menu(self.CmdBtn)
        self.CmdBtn.menu.add_command(label="Undo",command=self.DeleteOb)
        self.CmdBtn.menu.entryconfig(0, state=DISABLED)
        self.CmdBtn.menu.add_command(label='New', underline=0, command=self.ClearCanvas)
        self.CmdBtn.menu.add_command(label='About', underline=0,command=self.AboutWin)
        self.CmdBtn.menu.add('separator')
        self.CmdBtn.menu.add_command(label='Quit',underline=0,background='white',command=self.quit)
        self.CmdBtn['menu'] = self.CmdBtn.menu
        return self.CmdBtn


	
    def createWidgets(self):
	self.mBar = Frame(self, relief=RAISED)
        self.mBar.pack(side=TOP,fill=X,expand=YES)
        self.CmdBtn = self.makeCommandMenu()
	self.but1=Button(self,command=self.SetClock,text='Clock')
	self.but1.pack(side=TOP,fill=X)
	self.but2=Button(self,text='View',command=self.ViewResult)
	self.but2.pack(side=TOP,fill=X)
	self.but3=Button(self,command=self.SwitchClock,text='Switch Clock')
	self.but3.pack(side=TOP,fill=X)
	self.currentFunc   = None
	self.currentObject = None
	self.selObj   = None
	self.foreground   = 'black'
	self.background = 'white'
	self.fr1=Frame(self,relief=SOLID)
	self.radio = Pmw.RadioSelect(self.fr1, labelpos = None,buttontype = 'radiobutton', orient = VERTICAL,command = self.selectFunc, hull_borderwidth = 2,hull_relief = RIDGE)
        self.radio.pack(side=LEFT,expand=1)
        self.fr1.pack(side=LEFT)
	self.imglog = PhotoImage(file='images/logo.gif')
	self.lb = Label(self,image=self.imglog)
	self.lb.pack(side=RIGHT,fill=BOTH)	
	self.fr2=Frame(self,relief=RIDGE,borderwidth=5)
	self.can=Canvas(self.fr2,cursor="cross",width=800,height=600,bg="white")
        self.img1 = PhotoImage(file='images/And.gif')
	self.img2 = PhotoImage(file='images/Or.gif')
	self.img3 = PhotoImage(file='images/Not.gif')
	self.img4 = PhotoImage(file='images/Nand.gif')
	self.img5 = PhotoImage(file='images/Nor.gif')
	self.img6 = PhotoImage(file='images/Xor.gif')
	self.img7 = PhotoImage(file='images/FAdder.gif')
	self.img8 = PhotoImage(file='images/Div2.gif')
	self.img9 = PhotoImage(file='images/Counter.gif')
	self.img10 = PhotoImage(file='images/FF.gif')
	self.img11 = PhotoImage(file='images/Node.gif')
	self.img12 = PhotoImage(file='images/Latch.gif')
	self.img13  = PhotoImage(file='images/HAdder.gif')
	self.img14 = PhotoImage(file='images/Xnor.gif')
	self.imgcl = PhotoImage(file='images/Clock.gif')
	self.can.pack()
	self.fr2.pack(side=LEFT)
	Widget.bind(self.can, "<Button-1>", self.mouseDown)
	Widget.bind(self.can, "<Button1-Motion>", self.mouseMotion)
	Widget.bind(self.can, "<Button1-ButtonRelease>", self.mouseUp)
	self.func = {}
	for text, func in (('Select', self.AddValue),('And', self.drawAnd),('Or', self.drawOr),('Not', self.drawNot),('Nand',self.drawNand),('Nor',self.drawNor),('Xor',self.drawXor),('Xnor',self.drawXnor),('Full Adder',self.drawFAdder),('Half Adder',self.drawHAdder),('Div2',self.drawDiv2),('Counter',self.drawCounter),('FlipFlop',self.drawFlipFlop),('Latch',self.drawLatch),('Node',self.drawNode),('Clock',self.drawClock),('Connector',self.drawConnector)):
		self.radio.add(text)
		self.func[text] = func
	self.radio.invoke('Or')

    def selectFunc(self, tag):
     	self.currentFunc = self.func[tag]


    def mouseDown(self, event):
	self.currentObject = None
     	self.lastx = self.startx = self.can.canvasx(event.x)
     	self.lasty = self.starty = self.can.canvasy(event.y)
     	if self.currentFunc==self.AddValue:
        	self.selObj = self.can.find_closest(self.startx,self.starty)[0]
		

    def mouseMotion(self, event):
   	self.lastx = self.can.canvasx(event.x)
     	self.lasty = self.can.canvasy(event.y)
     	if self.currentFunc==self.drawConnector:
        	self.can.delete(self.currentObject)
          	self.currentFunc(self.startx, self.starty,self.lastx, self.lasty,self.foreground)

    def mouseUp(self, event):
     	self.lastx = self.can.canvasx(event.x)
     	self.lasty = self.can.canvasy(event.y)
     	self.can.delete(self.currentObject)
     	self.currentObject = None
	if self.currentFunc==self.drawConnector:
		if self.CheckConnection(self.startx,self.starty,self.lastx,self.lasty)==True:
			self.MakeConnection(self.startx,self.starty,self.lastx,self.lasty,self.foreground)
			return
		else:
			return
     	elif self.currentFunc==self.AddValue:
           	if self.selObj:
			self.AddValue()
        elif self.currentFunc:
           	self.currentFunc(self.startx, self.starty)

    def drawOr(self,x,y):
	self.currentObject=self.can.create_image(x,y,image=self.img2,anchor=CENTER)
	self.currentB=self.OrB=Or("Or")
	self.OrOb[self.currentObject]=self.OrB
	
	
    def drawAnd(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img1)
	self.AndB=And("And")
	self.AndOb[self.currentObject]=self.AndB


    def drawNot(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img3)
	self.NotB=Not("Not")
	self.NotOb[self.currentObject]=self.NotB

    def drawNand(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img4)
	self.NandB=Nand("Nand")
	self.NandOb[self.currentObject]=self.NandB

    def drawNor(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img5)
	self.NorB=Nor("Nor")
	self.NorOb[self.currentObject]=self.NorB

    def drawXor(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img6)
	self.XorB=Xor("Xor")
	self.XorOb[self.currentObject]=self.XorB

    def drawXnor(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img14)
	self.XnorB=Xnor("Xnor")
	self.XnorOb[self.currentObject]=self.XnorB

    def drawFAdder(self,x,y):
	self.currentObject = self.can.create_image(x,y,image=self.img7)
	self.FAdderB=FullAdder("Full Adder")
	self.FAdderOb[self.currentObject]=self.FAdderB

    def drawHAdder(self,x,y):
	self.currentObject = self.can.create_image(x,y,image=self.img13)
	self.HAdderB=HalfAdder("Half Adder")
	self.HAdderOb[self.currentObject]=self.HAdderB

    def drawDiv2(self,x,y):
	self.currentObject = self.can.create_image(x,y,image=self.img8)
	self.Div2B=Div2("Div2")
	self.Div2Ob[self.currentObject]=self.Div2B

    def drawCounter(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img9)
	self.CounterB=Counter("Counter")
	self.CounterOb[self.currentObject]=self.CounterB

    def drawFlipFlop(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img10)
	self.FlipB=DFlipFlop("DFlipFlop")
	self.FlipOb[self.currentObject]=self.FlipB

    def drawLatch(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img12)
	self.LatchB=Latch("Latch")
	self.LatchOb[self.currentObject]=self.LatchB

    def drawClock(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.imgcl)
	self.ClockB=Clock("Clock")
	self.ClockOb[self.currentObject]=self.ClockB

    def drawNode(self,x,y):
	self.currentObject = self.can.create_image(x, y, image=self.img11)
	self.NodeB=Node('Node')
	self.NodeOb[self.currentObject]=self.NodeB

    def drawConnector(self,x1,y1,x2,y2,fg):
	self.currentObject=self.can.create_line(x1,y1,x2,y2,fill=fg)

    def MakeConnection(self,x1,y1,x2,y2,fg):
	if self.save1==self.save2:
		return
	if self.save1.name=="Counter":	# Checks whether the first element is a Counter
		if y1<self.cord1[1] and y1<self.cord1[1]-6:
			newx1 = self.cord1[0]+48
			newy1 = self.cord1[1]-18
			con1 = self.save1.B0.C			
		elif y1>self.cord1[1]-6 and y1<self.cord1[1]+6:
			newx1 = self.cord1[0]+48
			newy1 = self.cord1[1]-6
			con1 = self.save1.B1.C	
		elif y1<self.cord1[1]+18 and y1>self.cord1[1]+6:
			newx1 = self.cord1[0]+48
			newy1 = self.cord1[1]+18
			con1 = self.save1.B2.C	
		else:
			newx1 = self.cord1[0]+48
			newy1 = self.cord1[1]+6
			con1 = self.save1.B3.C	
	elif self.save1.name=="Full Adder" or self.save1.name=="Half Adder":	# Checks whether the first element is a Full Adder or Half Adder
		if y1<self.cord1[1]:
			newx1 = self.cord1[0]+48
			newy1 = self.cord1[1]-18
			con1 = self.save1.S	
		else:
			newx1 = self.cord1[0]+48
			newy1 = self.cord1[1]+18
			con1 = self.save1.Cout	
	elif self.save1.name=="Clock":	# Checks whether the first element is a Clock Generator
		newx1 = self.cord1[0]+33
		newy1 = self.cord1[1]
		con1 = self.save1.A	
	elif self.save1.name=="Node":
		newx1 = self.cord1[0]
		newy1 = self.cord1[1]
		con1 = self.save1.B	
	elif self.save1.name=="Not":
		newx1 = self.cord1[0]+48
		newy1 = self.cord1[1]
		con1 = self.save1.B	
	else:				# This is for all other circuits with 2 Inputs
		newx1 = self.cord1[0]+48
		newy1 = self.cord1[1]
		con1 = self.save1.C	
	if self.save2.name=="Full Adder" or self.save2.name=="Half Adder":
		if y2<self.cord2[1]+18:
			newx2 = self.cord2[0]-48
			newy2 = self.cord2[1]-18
			con2 = self.save2.A
		elif y2<self.cord2[1]:
			newx2 = self.cord2[0]-48
			newy2 = self.cord2[1]
			con2 = self.save2.B
		else:	
			newx2 = self.cord2[0]-48
			newy2 = self.cord2[1]+18
			con2 = self.save2.Cin
	elif self.save2.name=="Node":
		newx2 = self.cord2[0]
		newy2 = self.cord2[1]
		con2 = self.save2.A
	elif self.save2.name=="Not":
		newx2 = self.cord2[0]-48
		newy2 = self.cord2[1]
		con2 = self.save2.A
	elif self.save2.name!="Clock":
		if y2<self.cord2[1]:
			newx2 = self.cord2[0]-48
			newy2 = self.cord2[1]-18
			con2 = self.save2.A
		else:
			newx2 = self.cord2[0]-48
			newy2 = self.cord2[1]+18
			con2 = self.save2.B
	if con2.connected!=True:
		con2.connected=True
		con1.connect([con2])
		con2.set(con1.value)
		self.currentObject=self.can.create_line(newx1,newy1,newx2,newy2,fill=fg,width=2)
	self.ViewResult()
	
    def CheckConnection(self,x1,y1,x2,y2):
	case1=case2=False
	self.ob1=self.can.find_closest(x1,y1,halo=None)
	self.ob2=self.can.find_closest(x2,y2,halo=None)
	self.cord1=self.can.coords(self.ob1)
	self.cord2=self.can.coords(self.ob2)
	for k in (self.AndOb,self.OrOb,self.NandOb,self.NotOb,self.NorOb,self.XorOb,self.XnorOb,self.FAdderOb,self.HAdderOb,self.CounterOb,self.LatchOb,self.FlipOb,self.Div2Ob,self.NodeOb,self.ClockOb):
		for i in k:
			if self.ob1[0]==i:
				case1=True
				self.save1=k[i]
			if self.ob2[0]==i:
				case2=True
				self.save2=k[i]
			if (case1 and case2):
				return True
	return False

    def AddValue(self):
	dialog = Pmw.Dialog(self,title='Circuit Parameters')
	self.AssocFun = self.FindFunc()
	if self.AssocFun == None:
		return
	if self.AssocFun.name=="Full Adder" or self.AssocFun.name=="Half Adder":
		self.ent1 = Pmw.EntryField(dialog.interior(), labelpos=W, label_text = 'Input A (0 or 1):',validate = {'validator' : 'numeric','min' : 0, 'max' : 1, 'minstrict' : 0},value = 0)
		self.ent1.pack(fill=X,expand=1,padx=10,pady=5)
		self.ent2 = Pmw.EntryField(dialog.interior(), labelpos=W, label_text = 'Input B (0 or 1):',validate = {'validator' : 'numeric','min' : 0, 'max' : 1, 'minstrict' : 0},value = 0)
		self.ent2.pack(fill=X,expand=1,padx=10,pady=5)
		if self.AssocFun.name=="Full Adder":
			self.ent3 = Pmw.EntryField(dialog.interior(), labelpos=W, label_text = 'Input Cin (0 or 1):',validate = {'validator' : 'numeric','min' : 0, 'max' : 1, 'minstrict' : 0},value = 0)
			self.ent3.pack(fill=X,expand=1,padx=10,pady=5)
		dialog.activate()
		self.valA = self.ent1.get()
		self.valB = self.ent2.get()
		if self.valA=='0':
			self.AssocFun.A.set(0)
		else:
			self.AssocFun.A.set(1)
		if self.valB=='0':
			self.AssocFun.B.set(0)
		else:
			self.AssocFun.B.set(1)
		if self.AssocFun.name=="Full Adder":
			self.valC = self.ent3.get()
			if self.valC=='0':
				self.AssocFun.Cin.set(0)
			else:
				self.AssocFun.Cin.set(1)
	elif self.AssocFun.name=="Not" or self.AssocFun.name=="Node":
		self.ent1 = Pmw.EntryField(dialog.interior(), labelpos=W, label_text = 'Input A (0 or 1):',validate = {'validator' : 'numeric','min' : 0, 'max' : 1, 'minstrict' : 0},value = 0)
		self.ent1.pack(fill=X,expand=1,padx=10,pady=5)
		dialog.activate()
		self.valA = self.ent1.get()
		if self.valA=='0':
			self.AssocFun.A.set(0)
		else:
			self.AssocFun.A.set(1)
	else:
		self.ent1 = Pmw.EntryField(dialog.interior(), labelpos=W, label_text = 'Input 1 (0 or 1):',validate = {'validator' : 'numeric','min' : 0, 'max' : 1, 'minstrict' : 0},value = 0)
		self.ent1.pack(fill=X,expand=1,padx=10,pady=5)
		self.ent2 = Pmw.EntryField(dialog.interior(), labelpos=W, label_text = 'Input 2 (0 or 1):',validate = {'validator' : 'numeric','min' : 0, 'max' : 1, 'minstrict' : 0},value = 0)
		self.ent2.pack(fill=X,expand=1,padx=10,pady=5)
		dialog.activate()
		self.valA = self.ent1.get()
		if self.valA=='0':
			self.AssocFun.A.set(0)
		else:
			self.AssocFun.A.set(1)
		self.valB = self.ent2.get()
		if self.valB=='0':
			self.AssocFun.B.set(0)
		else:
			self.AssocFun.B.set(1)
	self.ViewResult()
		
	
    def FindFunc(self):
	for k in (self.AndOb,self.OrOb,self.NandOb,self.NotOb,self.NorOb,self.XorOb,self.XnorOb,self.FAdderOb,self.HAdderOb,self.CounterOb,self.LatchOb,self.FlipOb,self.Div2Ob,self.NodeOb,self.ClockOb):
		for i in k:
			if self.selObj==i:
				return k[i]
	return None
	
				
    def SetClock(self):
	if self.ClockOb == {}:
		return
	if self.preclock==1:
		self.ClockOb.values()[self.CurClk].A.set(0)
		self.preclock=0
	else:
		self.ClockOb.values()[self.CurClk].A.set(1)
		self.preclock=1
	self.ViewResult()

    def SwitchClock(self):
	print len(self.ClockOb.values())
	if (len(self.ClockOb.values())-1 > self.CurClk):
		self.CurClk = self.CurClk + 1
	else:	self.CurClk = 0

    def ViewResult(self):
	for k in self.info:
		self.can.delete(k)
	self.info=[]
	self.AllOb=self.can.find_all()
	for k in self.AllOb:
		for j in (self.AndOb,self.OrOb,self.NandOb,self.NotOb,self.NorOb,self.XorOb,self.XnorOb,self.FAdderOb,self.HAdderOb,self.CounterOb,self.LatchOb,self.FlipOb,self.Div2Ob,self.ClockOb):
			for l in j:
				if l==k:
					cord=self.can.coords(k)
					if j[l].name=="Full Adder":
						self.info.append(self.can.create_text(cord[0],cord[1]+45, text='[%s,%s,%s] : [%s,%s]'%(j[l].A.value,j[l].B.value,j[l].Cin.value,j[l].S.value,j[l].Cout.value), fill='brown'))
					elif j[l].name=="Half Adder":
						self.info.append(self.can.create_text(cord[0],cord[1]+45, text='[%s,%s] : [%s,%s]'%(j[l].A.value,j[l].B.value,j[l].S.value,j[l].Cout.value), fill='brown'))
					elif j[l].name=="Counter":
						self.info.append(self.can.create_text(cord[0],cord[1]+45, text='[%s,%s] : [%s,%s,%s,%s]'%(j[l].A.value,j[l].B.value,j[l].B3.C.value,j[l].B2.C.value,j[l].B1.C.value,j[l].B0.C.value), fill='brown'))
					elif j[l].name=="Clock":
						self.info.append(self.can.create_text(cord[0],cord[1]+45, text='[%s]'%(j[l].A.value), fill='brown'))
					elif j[l].name=="Not" or j[l].name=="Not":
						self.info.append(self.can.create_text(cord[0],cord[1]+45, text='[%s] : [%s]'%(j[l].A.value,j[l].B.value), fill='brown'))
					else:
						self.info.append(self.can.create_text(cord[0],cord[1]+45, text='[%s,%s] : [%s]'%(j[l].A.value,j[l].B.value,j[l].C.value), fill='brown'))

    def DeleteOb(self):
	self.can.delete(self.currentObject)
	self.currentObject=None

    def ClearCanvas(self):
	self.AllOb=self.can.find_all()
	for k in self.AllOb:
		self.can.delete(k)
	self.Initialize()


app=pydcs()
app.master.title("PyDCS - Digital Circuit Simulator")
app.mainloop()
